<template>
	<div class="record_content">
		<div class="title">
            <el-row>
				<el-col :span="12" style="line-height: 32px;">物料清单维护</el-col>
				<el-col :span="12" style="text-align: right;">
					<el-button type="primary" icon="el-icon-plus" style="background: #004EA2;" @click="event">新增</el-button>
					<el-button icon="el-icon-delete" @click="dels" >删除</el-button>
				</el-col>
			</el-row>
		</div>
		<div>
            <el-dialog
            title="物料清单的维护"
            :visible.sync="dialogVisible"
            width="80%"
            :before-close="handleClose" :center="true">
            <div>
				<el-form>
				<el-row :gutter="2">
				<el-col :span="8">
					<el-form-item label="类型:">
					<el-select v-model="search.type" size="small" placeholder="请选择" style="width: 224px;margin-right: 30px;">
						<el-option label="橡胶连接器" :value="0"></el-option>
						<el-option label="金属连接器" :value="1"></el-option>
						<el-option label="湿插拔电连接器" :value="2"></el-option>
						<el-option label="分支组件" :value="3"></el-option>
					</el-select>
					</el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="工序">
                            <template>
                                <el-select v-model="search.work" 
                                placeholder="请选择" 
                                allow-create
                                filterable
                                @change="workevent"
                                >
                                    <el-option
                                    v-for="(item,index) in process"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.name">
                                    </el-option>
                                </el-select>
                                </template>
                        </el-form-item>
				</el-col>
				<el-col :span="8">
					<el-form-item label="工艺名称:">
					<el-select v-model="search.craft" size="small" placeholder="请选择" style="width: 224px;margin-right: 30px;">
						<el-option
							v-for="item in craftapi"
							:key="item.id"
							:label="item.name"
							:value="item.id">
							</el-option>
					</el-select>
				</el-form-item>
				</el-col>
				</el-row>
			</el-form>
				<el-button size="mini" @click="Addrow" >添加行</el-button>
			</div>
			<div style="margin: 10px 0px;">
				<template>
					<el-table
					border
					:data="tableapi"
					height="calc(80vh - 250px)"
					style="width: 100%">
					<el-table-column type="index" label="序号" width="70">
					</el-table-column>
					<el-table-column
						prop="date"
						label="供应商名称"
						width="180">
						<template slot-scope="scope">
							<el-input v-model="scope.row.supplier" placeholder="" ></el-input>
						</template>
					</el-table-column>
					<el-table-column
						prop=""
						label="质量追溯号"
						width="180">
						<template slot-scope="scope">
							<el-input v-model="scope.row.qualityTraceability" placeholder="" ></el-input>
						</template>
					</el-table-column>
					<el-table-column
						prop="name"
						label="原材料名称">
						<template slot-scope="scope">
							<el-input v-model="scope.row.name" placeholder="" ></el-input>
						</template>
					</el-table-column>
					<el-table-column
						prop="address"
						label="规格型号">
						<template slot-scope="scope">
							<el-input v-model="scope.row.specifications" placeholder="" ></el-input>
						</template>
					</el-table-column>
					<el-table-column
						prop="unit"
						label="单位">
						<template slot-scope="scope">
							<el-input v-model="scope.row.unit" placeholder="" ></el-input>
						</template>
					</el-table-column>
					</el-table>
				</template>
			</div>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogVisible = false">取 消</el-button>
                <el-button type="primary" @click="skipshow">确 定</el-button>
            </span>
            </el-dialog>
        </div>

		<div class="choose">
            <span>类型：</span>
			<el-select v-model="search.type" size="small" @change="TYpe" placeholder="请选择" style="width: 224px;margin-right: 30px;">
				<el-option label="橡胶连接器" :value="0"></el-option>
				<el-option label="金属连接器" :value="1"></el-option>
				<el-option label="湿插拔电连接器" :value="2"></el-option>
				<el-option label="分支组件" :value="3"></el-option>
			</el-select>
			<!-- <span>原材料名称：</span>
			<el-select v-model="search.name" size="small" placeholder="请选择" style="width: 224px;margin-right: 30px;">
				<el-option v-for="(a, ai) in process" key="ai" :label="a.name" :value="a.id"></el-option>
			</el-select>
			<el-button size="mini"><span>重 置</span></el-button>
			<el-button size="mini" type="primary" style="background: #004EA2;"><span>查询</span></el-button> -->
		</div>
		<div class="thing">
			<div class="left">
				<el-input v-model="search.technology" suffix-icon="el-icon-search" placeholder="请输入搜索内容" size="small" clearable ></el-input>
                <el-tree :data="list" ref="tree"  highlight-current
				:props="{children: 'children',label: 'name'}" 
				node-key="id" default-expand-all  @node-click="handleNodeClick" >
					<div class="custom-tree-node" slot-scope="{ node, data }">
						<span><i :class="`node_i ${data.code != '[2]'?'el-icon-folder-opened':'el-icon-tickets'}`"></i>
							{{data.code}} {{ data.name }}</span>
						<!-- <el-button type="text" size="mini" @click.stop="remove(node, data)">
							<i class="el-icon-delete"></i>
						</el-button> -->
					</div>
				</el-tree>
			</div>
			<div class="right">
                <el-table :data="tableData" border style="width: 100%;overflow-y: auto;min-height: 100%" max-height="100%"
					@selection-change="handleSelectionChange" default-expand-all>
					<el-table-column type="selection" width="50">
					</el-table-column>
					<el-table-column type="index" label="序号" width="70">
					</el-table-column>
					<el-table-column prop="name" label="原材料名称">
					</el-table-column>
					<el-table-column prop="unit" label="单位">
					</el-table-column>
					<el-table-column label="操作" width="130">
						<template slot-scope="scope">
							<!-- <span class="table_do" @click="upContent(scope.row)">编辑&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span> -->
							<span class="table_do" @click="deleteRow(scope.$index, scope.row)">删除</span>
						</template>
					</el-table-column>
				</el-table>
			</div>
		</div>
		<!-- <el-dialog title="编辑记录内容" :visible.sync="upDia" width="500px">
			<div class="body">
			
			</div>
			
		</el-dialog> -->
	</div>
</template>
<script>
export default {
		data() {
			return {
              search:{
					type: 0,
					technology: null
				},
              list:[],
				process:{},
				// handleClose:[],
				checkTreeNode:{
					id:2,
				},
				tableData:[],
				tableapi:[{
					supplier:'',
					qualityTraceability:'',
					name:'',
					specifications:'',
					unit:'',
					}],
				addsearch:{},
				upData:{},
				form:{},
				dialogVisible:false,
				typeselect:0,
				input:'',
				craftapi:[],
            }
        },
		mounted() {
			this.selectAllleft() 
			this.selectAllMbom()         
		},
		methods:{
			selectDataList() {
				this.list.forEach(a => {
					a.code = '[1]'
					if (a.children != undefined) {
						a.children.forEach(b => {
							b.code = '[2]'
							if (b.children != undefined) {
								b.children.forEach(c => {
									c.code = '[3]'
								})
							}
						})
					}
				})
				this.upIndex++
			},
			 workevent(val){
                console.log(val);
                let idx = this.process.findIndex(el => el.name === val)
                this.craftapi = this.process[idx].children
            },
			//新增
			chooseTechFath() {
			this.$axios.get(this.$api.url.chooseTechFath,{
                params:{type:this.typeselect}
            }).then(res => {
				this.process = res.data;
                console.log(this.process);
			}, {
				headers: {
                		"Content-Type": "application/json"
              		}
            })
			},
			addMbom(data) {
				this.$axios.post(this.$api.url.addMbom,data
				// {
					// name:this.tableapi.name,
					// qualityTraceability:this.tableapi.qualityTraceability,
					// specifications:this.tableapi.specifications,
					// supplier:this.tableapi.supplier,
					// techTemId:this.craftapi.id,
					// unit:this.tableapi.unit,
				// }
				, {
					headers: {
                		"Content-Type": "application/json"
              		}
				}).then(res =>{
					console.log(res);
					this.$message.success('添加完成')
					this.selectAllMbom()
					this.tableapi = [{}]
				})
			},
			//删除
			material(index) {
				console.log(this.upData.id);
				this.$axios.post(this.$api.url.material,{
					id:this.upData.id
				}).then(res =>{
					this.$message.success(res.message)
					this.tableData.splice(index,1)

					// console.log(res);
				})
			},
			TYpe(val) {
				this.typeselect = val
				this.selectAllleft()
			},
			//左边
			selectAllleft() {
			this.$axios.get(this.$api.url.selectAllleft,{
				params:{type:this.typeselect}
			}).then(res => {
				this.list = res.data;
				console.log(this.list);
				this.selectDataList()
			}, {
				headers: {
                		"Content-Type": "application/json"
              		}
            })
			},
			//右边
			selectAllMbom() {
			this.$axios.get(this.$api.url.selectAllMbom,{
				params:{id:this.checkTreeNode.id}
			}).then(res => {
				this.tableData = res.data;
				console.log(this.tableData);
			}, {
				headers: {
                		"Content-Type": "application/json"
              		}
            })
			},
			handleNodeClick(data){
                this.checkTreeNode = data
				console.log(this.checkTreeNode.id);
				this.selectAllMbom()
            },
			handleClose(done) {
				this.$confirm('确认关闭？')
				.then(_ => {
					done();
				})
				.catch(_ => {});
			},
            event(){
                this.dialogVisible = true
				this.chooseTechFath()
            },
			 Addrow() {
			if (this.tableapi == undefined) {
				this.tableapi = new Array();
			}
			let obj = [];
			
			this.tableapi.push(obj);
			},
			skipshow(){
				console.log('666');
				let data = this.tableapi.at(-1)
				// this.addMbom()
				data.techTemId = this.search.craft
				// console.log(this.search.craft);
				// console.log(data);

				this.addMbom(data)
				
				this.dialogVisible = false
			},
			dels() {
				this.selects.forEach(a => {
					for (var b = 0; b < this.tableData.length; b++) {
						if (this.tableData[b].id == a.id) {
							this.tableData.splice(b, 1)
							b--
						}
					}
				})
				this.$message.success('删除完成')
			},
			handleSelectionChange(val) {
				this.selects = val;
			},
			deleteRow(index, rows) {
				console.log(rows);
				// this.tableData.splice(index,1)
				this.upData.id = rows.id
				console.log(this.upData);
				this.material(index)
			},

        }
    }
</script>

<style scoped>
	.title .el-button {
		height: 32px;
		border: 1px solid rgba(190, 190, 190, 0.44);
		box-shadow: 0px 2px 4px rgba(220, 220, 220, 0.41);
		padding: 0 12px;
	}

	.title {
		margin-bottom: 10px;
		padding: 0 20px;
	}

	.title * {
		font-size: 16px;
	}
	.choose-1{
		padding: 5px 24px;
		display: flex;
		align-items: center;
		background-color: #fff;
		border-bottom: 3px solid rgb(245, 247, 251);
	}

	.choose {
		padding: 21px 24px;
		display: flex;
		align-items: center;
		background-color: #fff;
		border-bottom: 3px solid rgb(245, 247, 251);
	}

	.choose * {
		font-size: 14px;
	}

	.choose .el-button {
		height: 32px;
		border: 1px solid rgba(190, 190, 190, 0.44);
		box-shadow: 0px 2px 4px rgba(220, 220, 220, 0.41);
		padding: 0 12px;
	}

	.thing {
		width: 100%;
		height: calc(100% - 120px);
		background-color: #fff;
		display: flex;
	}

	.thing .left {
		width: 295px;
		height: calc(100% - 20px);
		border-right: 3px solid rgb(245, 247, 251);
		padding: 16px;
	}

	.thing .left .custom-tree-node span {
		font-size: 14px;
	}

	.thing .left .custom-tree-node {
		flex: 1;
		display: flex;
		align-items: center;
		justify-content: space-between;
		font-size: 14px;
		padding-right: 8px;
	}

	.node_i {
		color: orange;
	}

	.el-icon-delete {
		display: none;
		color: #004EA2;
	}

	.custom-tree-node:hover .el-icon-delete {
		display: inline;
	}

	.thing .right {
		width: calc(100% - 305px);
		height: calc(100% - 25px);
		overflow: hidden;
		padding: 10px;
	}

	.table_do {
		color: #004ea0;
		cursor: pointer;
	}
</style>
<style>
	.record_content .title .el-button * {
		font-size: 14px;
	}

	.record_content .title .el-button--default {
		color: #004EA2;
	}

	.record_content .thing .left .el-tree--highlight-current .el-tree-node.is-current>.el-tree-node__content {
		background: rgba(58, 124, 253, 0.2);
		color: #004EA2;
	}

	.record_content .el-tree-node__content {
		height: 30px;
		border-radius: 2px;
	}
</style>
